/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package clientwizard;

import java.awt.CardLayout;
import java.io.File;
import javax.swing.JPanel;

/**
 *
 * @author idrago
 */
public class Wizard extends javax.swing.JFrame {
    public static Wizard self;
    public String WZ1 = "WZ1";
    public String WZ2 = "WZ2";
    public String WZ3 = "WZ3";   
    public File dropbox_folder;
    public String orig_folder = "";
    public boolean found_folder = false;
    public boolean def_folder = true;
    public boolean match_folder = true;    
    public FileTable filetable;    
    public StringBuilder error_log = new StringBuilder();
    
    public String HOME;
    public File HOSTKEYS;
    public File HOSTDB;
    
    /**
     * Creates new form Wizard_step1
     */
    public Wizard() {
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        try { 
            javax.swing.UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel"); 
        } catch (Exception ex) { 
            System.out.println(ex.toString()); 
        }

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                self = new Wizard();
                self.initComponents();
                
                self.HOSTKEYS = self.getHostKeys();
                self.HOSTDB = self.getHostDB();
                self.HOME = System.getProperty("user.home");

                self.dropbox_folder = self.panel_wz1.setInitialFolder();
                self.setVisible(true);
            }
        });
    } 
        
    @SuppressWarnings("unchecked")
    private void initComponents() {
        filetable = new FileTable(self);
        panel_wz1 = new Wizard_step1(self);
        panel_wz2 = new Wizard_step2(self);
        panel_wz3 = new Wizard_step3(self);
        
        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Help our research");
        setMinimumSize(new java.awt.Dimension(585, 400));
        setName("main"); // NOI18N
        setResizable(false);
        setIconImage(new javax.swing.ImageIcon(getClass().getResource("/icons/preferences-desktop-accessibility.png")).getImage());
        
        //Create the panel that contains the "cards".
        cardlayout = new CardLayout();
        cards = new JPanel(cardlayout);
        cards.add(panel_wz1.panel_main, WZ1);
        cards.add(panel_wz2.panel_main, WZ2);
        cards.add(panel_wz3.panel_main, WZ3);
        swapView(WZ1);
        getContentPane().add(cards);

        pack();
    }
    
    public void swapView(String key) {
       cardlayout.show(cards, key);
    }    
    
    public File getHostKeys() {
        if (isWindows()) {
            /* In windows, it should come from the registry */
            return null;   
        } else {
            String appdata = System.getProperty("user.home") + File.separator + ".dropbox" + File.separator + "hostkeys";
            File tmp = new File(appdata);
            if (tmp.exists() && tmp.canRead()) {
                return tmp;
            }
        }
        return null;   
    }   

    public File getHostDB() {
        String appdata;
        if (isWindows()) {
            appdata = System.getenv("APPDATA") + File.separator + "Dropbox" + File.separator + "host.db";   
        } else {
            appdata = System.getProperty("user.home") + File.separator + ".dropbox" + File.separator + "host.db";
        }
        File tmp = new File(appdata);
        if (tmp.exists() && tmp.canRead()) {
            return tmp;
        }        
        return null;  
    }     
    
    public Wizard_step1 panel_wz1;
    public Wizard_step2 panel_wz2;
    public Wizard_step3 panel_wz3;
    private CardLayout cardlayout;
    private JPanel cards;
    
    public boolean isWindows() {
        return (System.getProperty("os.name").toLowerCase().indexOf("win") >= 0);
    }
}
